/*
N_Ejercicio : Me indica que ejercicio debo ejecutar
Lectura_ADC : Contiene la conversion Analogico/Digital
Contador    : Numero de interupciones que voy a contar
Numero      : Led encendido en el PORTB
Cantidad    : Numero de led al que le debo acertar
Pulso       : Verifica que la tecla se haya presionado y soltado
Start       : Para saber si se puede presionar la tecla de arranque
Jugando     : Para saber que la interrupcion se debe mantener habilitada
*/

unsigned int N_Ejercicio, Lectura_ADC, Contador, Numero, Cantidad, Pulso, Start, Jugando, i;
long PuertoB;

void interrupt(){
  Contador++;               // Con una interrupcin el Contador se incrementa en 1
  TMR0 =217;                // El valor inicial se devuelve en el temporizador TMR0
  INTCON = 0x20;            // Bit T0IE se pone a 1, el bit T0IF se pone a 0

}
unsigned short Display_Code(unsigned int numero){
  switch (numero) {
    case 0 : return 0x3F;
    case 1 : return 0x06;
    case 2 : return 0x5B;
    case 3 : return 0x4F;
    case 4 : return 0x66;
    case 5 : return 0x6D;
    case 6 : return 0x7D;
    case 7 : return 0x07;
    case 8 : return 0x7F;
    case 9 : return 0x6F;
  }
}

unsigned short Encender_Led(unsigned int numero){
  switch (numero) {
    case 1 : return 0x80;
    case 2 : return 0xC0;
    case 3 : return 0xE0;
    case 4 : return 0xF0;
    case 5 : return 0xF8;
    case 6 : return 0xFC;
    case 7 : return 0xFE;
    case 8 : return 0xFF;
  }
}

unsigned short Display_Led(unsigned int numero){
  switch (numero) {
    case 1 : return 0x01;
    case 2 : return 0x02;
    case 3 : return 0x04;
    case 4 : return 0x08;
    case 5 : return 0x10;
    case 6 : return 0x20;
    case 7 : return 0x40;
    case 8 : return 0x80;
  }
}

void Habilita_Interrupcion(){
  OPTION_REG = 0x07;        // Pre-escalador (1:256) se le asigna al temporizador Timer0
  TMR0 = 217;               // Temporizador T0 cuenta de 178 a 255
  INTCON = 0xA0;            // Habilitada la generacin de interrupcin para el temporizador Timer0
  Contador = 0;             // Inicializa el Contador de interrupciones
  Numero = 0;               // Inicializa el Numero de led encendido en PORTB
}

void Deshabilita_Interrupcion(){
  INTCON = 0x00;            // Se deshabilitan la interrupciones
}

void Verificar_Ejercicio(){
  if(RA1_bit){
    N_Ejercicio = 1;
    Deshabilita_Interrupcion();
  }
  if(RA2_bit){
    N_Ejercicio = 2;
    PORTB = 0;
    PORTC = 0x00;
    PORTD = 0x00;
    Cantidad = 0;
  }
}

/*unsigned int Invertir_Valor(unsigned int valor){
  int i=0,j=0;
  unsigned int copia = 0;
  unsigned int resultado = 0;
  for (i=0;i<8;i++){
      copia = valor;
      j=2+i;
      copia = copia << j;
      copia = copia >> 9;
      copia = copia << i;
      resultado = resultado + copia;
  }
  return resultado;
}*/

void main() {
  Deshabilita_Interrupcion();
  ANSEL = 0x01;                  // Pin AN0(RA0) se configura como analgico
  ANSELH = 0x00;                 // Los dems pines se configuran como digitales
  TRISA = 0xFF;                  // Todos los pines del puerto PORTA se configuran como entradas
  PORTB = 0x00;                  // Valor inicial asignado al PORTB
  TRISB = 0x00;                  // Todos los pines del PORTB se configuran como salidas
  PORTC = 0x00;                  // Valor inicial asignado al PORTC
  TRISC = 0x00;                  // Todos los pines del PORTC se configuran como salidas
  PORTD = 0x00;                  // Valor inicial asignado al PORTD
  TRISD = 0x00;                  // Todos los pines del PORTD se configuran como salidas
  ADCON1 = 0x82;                 // Voltaje de referencia para la conversin A/D es VCC
  PORTD = 0x79;                  // Muestro la letra E
  PORTC = 0x3E;                  // Muestro la letra V
  N_Ejercicio = 0;

  while(1){
    Verificar_Ejercicio();
    if(N_Ejercicio == 1){
      Lectura_ADC = ADC_Read(0);                 // Resultado de la conversin A/D es copiado a lectura
      PuertoB = (long)Lectura_ADC*255/1023;      // Ponderamos la lectura del ADC a 8 bits
      PORTB = PuertoB;
      PORTC = Display_Code((PuertoB*99/255)%10); // Ponderamos la lectura en un rango de 00 a 99 y mostramos unidades
      PORTD = Display_Code((PuertoB*99/255)/10); // Ponderamos la lectura en un rango de 00 a 99 y mostramos decenas
    }
    if(N_Ejercicio == 2){
      if(Button(&PORTA, 3,0,1))
          Pulso = 1;
      while(Pulso == 1){
        if(Pulso == 1 && Button(&PORTA, 3,0,0)){
          if(Cantidad == 8)
            Cantidad = 1;
          else
            Cantidad++;
          PORTC = Display_Code(Cantidad);
          PORTD = 0x38;
          Pulso = 0;
          Start = 1;
        }
      }
      if(Button(&PORTA, 4,0,1) && Start == 1){
        Jugando = 1;
        Numero = 1;
      }
      while(Jugando == 1){
        if(Jugando == 1 && Button(&PORTA, 4,0,0)){
          Habilita_Interrupcion();
          while(Button(&PORTA, 3,0,0)){
            if(Contador == 10){
              if(Numero == 8)
                Numero = 1;
              else
                Numero++;
              Contador = 0;
              PORTB = Display_Led(Numero);
            }
          }
          Deshabilita_Interrupcion();
          if(Numero == Cantidad){
             Delay_ms(500);
             PORTB = 0;
             for(i=1;i<=20;i++){
               if (PORTB == 0)
                 PORTB = 255;
               else
                 PORTB = 0;
               Delay_ms(80);
             }
          }
          if(Numero != Cantidad){
            Delay_ms(500);
            for(i=8;i>0;i--){
              PORTB = Encender_Led(i);
              Delay_ms(80);
            }
          }
          Jugando = 0;
          Start = 0;
          PORTB = 0x00;
          PORTC = 0x00;
          PORTD = 0x00;
          Cantidad = 0;
        }
      }
    }
  }
}